"""
@author: luojunhui
好看视频搜索爬虫
"""
import requests
import urllib.parse
import time
import hashlib


def get_video_detail(video_id):
    """
    获取好看视频的视频链接
    :param video_id:
    :return:
    """
    url = "https://haokan.baidu.com/v"
    params = {
        'vid': video_id,
        '_format': 'json',
        # 'hk_nonce': 'f47386e95fe657182aa3c1826d9a6b85',
        # 'hk_timestamp': '1715225386',
        # 'hk_sign': '4b219f5e3971e42b3e23dc2a209fc9d9',
        # 'hk_token': 'Dg8DdAVwdwNzDHcFcXF+D3gHBQA'
    }

    headers = {
        'Accept': '*/*',
        'cookie': "BIDUPSID='",
        'Accept-Language': 'en,zh;q=0.9,zh-CN;q=0.8',
        'Cache-Control': 'no-cache',
        'Connection': 'keep-alive',
        'Content-Type': 'application/x-www-form-urlencoded',
        'Referer': 'https://haokan.baidu.com',
        'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/124.0.0.0 Safari/537.36',
    }
    response = requests.request("GET", url, headers=headers, params=params).json()
    # print(json.dumps(response['data']['apiData']['curVideoMeta'], ensure_ascii=False, indent=4))
    return response['data']['apiData']['curVideoMeta']


def hksp_search(key):
    """
    好看视频搜索爬虫
    """
    timestamp_seconds = time.time()
    timestamp_milliseconds = int(timestamp_seconds * 1000)
    url = 'https://haokan.baidu.com/haokan/ui-search/pc/search/video'
    # 定义请求的参数
    strings = "{}_{}_{}_{}_{}".format(1, urllib.parse.quote(key), 10, timestamp_milliseconds, 1)
    sign = hashlib.md5(strings.encode()).hexdigest()
    params = {
        'pn': 1,
        'rn': 10,
        'type': 'video',
        'query': key,
        'sign': sign,
        'version': 1,
        'timestamp': timestamp_milliseconds
    }
    # 定义请求头
    headers = {
        'authority': 'haokan.baidu.com',
        'accept': '*/*',
        'accept-language': 'zh,en;q=0.9,zh-CN;q=0.8',
        'cookie': "BIDUPSID='",
        # 'referer': 'https://haokan.baidu.com/web/search/page?query=%E8%80%81%E4%BA%BA',
        'sec-ch-ua': '"Not A(Brand";v="99", "Google Chrome";v="121", "Chromium";v="121"',
        'sec-ch-ua-mobile': '?0',
        'sec-ch-ua-platform': '"macOS"',
        'sec-fetch-dest': 'empty',
        'sec-fetch-mode': 'cors',
        'sec-fetch-site': 'same-origin',
        'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/121.0.0.0 Safari/537.36',
        'x-requested-with': 'xmlhttprequest',
    }
    # 发送GET请求
    response = requests.get(url, headers=headers, params=params).json()
    # print(json.dumps(response, ensure_ascii=False, indent=4))
    data_list = response['data']['list']
    L = []
    for data in data_list[:5]:
        try:
            video_id = data['vid']
            res = get_video_detail(video_id)
            temp = ["haokanshipin", res['title'], res['playurl'], "https://haokan.baidu.com/v?vid={}".format(video_id)]
            L.append(temp)
        except:
            pass
    return L


if __name__ == '__main__':
    hksp_search("美国竟对中国提出4个荒唐的条件，真是好大的口气")
